var Wxss = require('./wxss');
var path = require('path');
var fs = require('fs');
var debug = require('debug')('wevue');

module.exports = function(wxFolder, vueFolder, rootFolder, wevueFolder, program) {

    var server = "";
    if (program.server && program.server !== true) {
        server = "SERVER="+program.server;
    }

    var distPath = "DIST_PATH=" +(process.env.DIST_PATH　 || '/dist/');
    var packageJson = path.join(wevueFolder, 'vue', 'package.json');
    var destPackageJson = path.join(vueFolder, 'package.json');

    debug('packageJson', packageJson);
    debug('destPackageJson', destPackageJson);

    if (fs.existsSync(packageJson)) {
        debug('replace');
        var packageContent = fs.readFileSync(packageJson, 'utf8');
        var packageJSON = JSON.parse(packageContent);
        var template = packageJSON["scripts-template"];
        packageJSON.scripts["dev"] = template.dev.replace("{{SERVER}}", server).replace("{{DIST_PATH}}", distPath);
        if (distPath.substr(distPath.length - 1) != '/') {
            distPath = distPath + '/';
        }
        packageJSON.scripts["build"] = template.build.replace("{{DIST_PATH}}", distPath);

        delete packageJSON["scripts-template"];
        content = JSON.stringify(packageJSON, null, 4);
        debug(content);
        fs.writeFileSync(destPackageJson, content);
    }
}
